//+------------------------------------------------------------------+
//|                                                        trade.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"
#property show_inputs 

#include <stdlib.mqh>
#include <WinUser32.mqh>

//+------------------------------------------------------------------+
//| script "trading for all money"                                   |
//+------------------------------------------------------------------+
extern double    Lots = 10.0;
extern int       StopLoss=15;
extern int       TakeProfit=10;
extern int       Slippage=3;
extern int       MAGICnumber = 250568;
extern string    ComPos="Redracer";

int start()
  {
   double StopLostPrice;
   double TakeProfitPrice;
   
   if (StopLoss > 0)
         StopLostPrice = Bid+(StopLoss*Point);
   else
         StopLostPrice = 0;

   if (TakeProfit > 0)
       TakeProfitPrice = Bid-(TakeProfit*Point);
   else
       TakeProfitPrice = 0;

         
   int ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,Slippage,StopLostPrice,TakeProfitPrice,ComPos,MAGICnumber,0,CLR_NONE);
   if(ticket<1)
     {
      int error=GetLastError();
      Print("Error = ",ErrorDescription(error));
      return;
     }
//----
   OrderPrint();
   return(0);
  }
//+------------------------------------------------------------------+