//+------------------------------------------------------------------+
//|                                             ap.cobra thv 1.0.mq4 |
//|                              Copyright  2008, fxid10t@yahoo.com |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, fxid10t@yahoo.com"
#property link      "www.ooida.com"

//external variables
extern int     Slippage          =1;

extern string  Ordercomment      ="ap.cobra thv 1.0";
extern int     MagicNumber       =1776;

extern bool       Use.Money.Mgt  =true;   // if false, uses Minimum.Lot
extern double     Minimum.Lot    =0.01;   // Smallest lot size to trade, Use.MM true or false
extern double     MaximumRisk    =0.0025; // %account balance to risk per position


//internal variables
double tv, Lp2c, Sp2c;
int Bticket,Sticket,ordertype,slippage;
double spread,bprice,sprice,ssl,bsl,btp,stp,MaxDrawDown,MaxMargin,lot,Margin,Balance, slpoint;
datetime shorttime,longtime,expire;
color Color;bool result; string swap;
/*Avg.Price*/double buys, sells, bap, sap, blots, slots, Lswap, Sswap, LProfit, SProfit;
/*MAE*/double lmae,smae; int ot,ct;
string comment;

int init()  {Avg.Price(); AccountExtremes();   MAE(); comments();return(0);}

int deinit(){return(0);}

int start() {
spread=Ask-Bid; Avg.Price(); AccountExtremes(); MAE(); comments();

//delete excess expert created objects
if(/*DayOfWeek()==1 && */Hour()==0 && Minute()<=1)   {
   for(int i=ObjectsTotal();i>=100;i--)  {
      if(StringSubstr(ObjectName(i),0,1)=="#")  {
         ObjectDelete(ObjectName(i));  }  }  }

double hull=iCustom(Symbol(),0,"hull THV",55,0.2,0,0);
double T3=iCustom(Symbol(),0,"T3 THV",8,0.04,0,0);
double hao=iCustom(Symbol(),0,"Heiken Ashi THV",CLR_NONE,CLR_NONE,MediumVioletRed,Green,0,0);
double hac=iCustom(Symbol(),0,"Heiken Ashi THV",CLR_NONE,CLR_NONE,MediumVioletRed,Green,1,0);
double haop=iCustom(Symbol(),0,"Heiken Ashi THV",CLR_NONE,CLR_NONE,MediumVioletRed,Green,0,1);
double hacp=iCustom(Symbol(),0,"Heiken Ashi THV",CLR_NONE,CLR_NONE,MediumVioletRed,Green,1,1);
double ia=iCustom(Symbol(),0,"Ichimoku THV",2,5,8,2,0);
double ib=iCustom(Symbol(),0,"Ichimoku THV",2,5,8,3,0);
double osma1=iCustom(Symbol(),0,"OsMA",12,26,7,0,0);
double osma2=iCustom(Symbol(),0,"OsMA",12,26,7,0,1);

//exit open positions?
for(int o=0; o<OrdersTotal(); o++)   {
   OrderSelect(o,SELECT_BY_POS,MODE_TRADES);
   if(OrderSymbol()==Symbol() && OrderMagicNumber()==MagicNumber)  {
      if(OrderType()==1 || OrderType()==3 || OrderType()==5)   {  Sticket=OrderTicket();  }
      if(OrderType()==0 || OrderType()==2 || OrderType()==4)   {  Bticket=OrderTicket();  }
      if(OrderType()==1)   {
         if((hao<hac && osma1>osma2) ||
            (Bid>T3) ||
            (Bid>ia && Bid>ib) &&
            shorttime<Time[0])  {
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Black);
               shorttime=Time[1];   }  }   
      if(OrderType()==0)    {
         if((hao>hac && osma1<osma2) ||
            (Ask<T3) ||
            (Ask<ia && Ask<ib) &&
            longtime<Time[0])  {
               OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Black);
               longtime=Time[1]; }  }  }  }

//ORDER ENTRY SETUP 0-buy,2-buylimit,4-buystop
sprice=0;bprice=0;ssl=0;bsl=0;
if(OrderSelect(Sticket,SELECT_BY_TICKET)==false || (OrderSelect(Sticket,SELECT_BY_TICKET)==true && OrderCloseTime()>0)) {
   if(Bid<T3/*hull && T3<hull && hac<hao && Bid<ia && Bid<ib*/ && shorttime<Time[0] )  {
      ordertype=1; sprice=Bid; ssl=Ask+(50*Point); 
      stp=0; slippage=Slippage; expire=0;
      Color=LightSalmon; Sell(); return(0);  }  }

if(OrderSelect(Bticket,SELECT_BY_TICKET)==false || (OrderSelect(Bticket,SELECT_BY_TICKET)==true && OrderCloseTime()>0)) {
   if(Ask>T3/*hull && T3>hull && hac>hao && Ask>ia && Ask>ib*/ && longtime<Time[0] )  {
      ordertype=0; bprice=Ask; bsl=Bid-(50*Point); 
      btp=0; slippage=Slippage; expire=0;
      Color=Green; Buy(); return(0);  }   }

return(0);}
//+------------------------------------------------------------------+
void AccountExtremes()   {
   //double MaxMargin, MaxDrawDown;
   if(AccountMargin()>MaxMargin)    MaxMargin=AccountMargin();
   if(AccountProfit()<MaxDrawDown)  MaxDrawDown=AccountProfit();   }

void Avg.Price() {//copy and paste variables to before init.
   /*Avg.Price*///double buys, sells, bap, sap, blots, slots, Lswap, Sswap, LProfit, SProfit;
   buys=0;blots=0;sells=0;slots=0;Lswap=0;Sswap=0;LProfit=0;SProfit=0;
   for(int c=0; c<OrdersTotal(); c++) {
      OrderSelect(c,SELECT_BY_POS,MODE_TRADES);
         if(OrderSymbol()==Symbol()) {
            if(OrderType()==OP_BUY)    {  
               buys+=(OrderOpenPrice()*OrderLots()); blots+=OrderLots();
               Lswap+=OrderSwap(); LProfit+=OrderProfit();   }
            if(OrderType()==OP_SELL)   {  
               sells+=(OrderOpenPrice()*OrderLots()); slots+=OrderLots();
               Sswap+=OrderSwap(); SProfit+=OrderProfit();  }  }  }

   Pips2Cover();

   if(buys>0)     { bap=buys/blots; bap=NormalizeDouble(bap+Lp2c,Digits);    }
   if(buys<=0)    { bap=0; buys=0; blots=0; Lp2c=0; }
   if(sells>0)    { sap=sells/slots; sap=NormalizeDouble(sap+Sp2c,Digits);   }
   if(sells<=0)   { sap=0; sells=0; slots=0; Sp2c=0;}

   if(ObjectFind("Average Buys")>-1) ObjectMove("Average Buys",0,Time[0],bap);
   if(ObjectFind("Average Sells")>-1)  ObjectMove("Average Sells",0,Time[0],sap);

   if(bap==0) { ObjectDelete("Average Buys"); }
   if(sap==0) { ObjectDelete("Average Sells");}
   if(bap>0)   {
      ObjectCreate("Average Buys",1,0,Time[10],bap);
      ObjectSetText("Average Buys","Average Buys");
      ObjectSet("Average Buys",6,LimeGreen);
      ObjectSet("Average Buys",7,STYLE_SOLID);
      ObjectSet("Average Buys",8,1);
      ObjectSet("Average Buys",9,true);   }
   if(sap>0)   {
      ObjectCreate("Average Sells",1,0,Time[10],sap);
      ObjectSetText("Average Sells","Average Sells");
      ObjectSet("Average Sells",6,LightSalmon);
      ObjectSet("Average Sells",7,STYLE_SOLID);
      ObjectSet("Average Sells",8,1);
      ObjectSet("Average Sells",9,true);   } } //end Average.Price

double Pips2Cover() {
   //double tv, Lp2c, Sp2c;
   tv=MarketInfo(Symbol(),16);
   if(Lswap!=0) {
      if(Lswap>0) {
         Lp2c=-MathFloor(Lswap/(tv*blots))*Point;  }
      if(Lswap<0) {
         Lp2c=MathFloor(Lswap/(tv*blots))*Point;  }   }
   if(Sswap!=0) {
      if(Sswap>0) {
         Sp2c=-MathFloor(Sswap/(tv*slots))*Point;  }
      if(Sswap<0) {
         Sp2c=MathFloor(Sswap/(tv*slots))*Point;  }   }  }//end Pips2Cover()

void Buy()  {//string Ordercomment; int MagicNumber, ticket; color Color;
/*   if(lmae>0)  {
      bsl=NormalizeDouble( MathMax(bsl,bprice-(lmae*1.236)),Digits);  }*/
   Bticket=OrderSend(Symbol(),ordertype,LotsOptimized(),bprice,//Ask
                    slippage,
                    bsl,//no stoploss defined
                    btp,//no tp defined
                    Ordercomment,//comment
                    MagicNumber,
                    expire,//time expire,
                    Color);
                    if(Bticket>0)   {
                        if(OrderSelect(Bticket,SELECT_BY_TICKET,MODE_TRADES)) {  
                        longtime=Time[0]; Print(Bticket);   }
                        else Print("Error Opening BuyStop Order: ",GetLastError());
                    return(0);   }  }//end Buy();

void Sell() {//string Ordercomment; int MagicNumber, ticket; color Color;
/*   if(smae>0)  {
      ssl=NormalizeDouble( MathMin(ssl,sprice+(smae*1.236)),Digits);  }*/
   Sticket=OrderSend(Symbol(),ordertype,LotsOptimized(),sprice,//Bid
                    slippage,
                    ssl,//no stoploss set when stop order is executed
                    stp,//no tp defined
                    Ordercomment,
                    MagicNumber,
                    expire,//time expire,
                    Color);
                    if(Sticket>0)   {
                        if(OrderSelect(Sticket,SELECT_BY_TICKET,MODE_TRADES)) {  
                        shorttime=Time[0]; Print(Sticket);   }
                        else Print("Error Opening SellStop Order: ",GetLastError());
                    return(0);   }  }//End Sell();

double LotsOptimized()  {
   double openprice, stoploss, risk;
   Margin=MathMin( MathMin(AccountBalance(),AccountEquity() ) , AccountFreeMargin() );
   if( (ordertype==0 || ordertype==2 || ordertype==4) && bprice-bsl>0)  {   
      risk=(Margin*MaximumRisk)/((bprice-bsl)/Point);  }
   if( (ordertype==1 || ordertype==3 || ordertype==5) && ssl-sprice>0)  {
      risk=(Margin*MaximumRisk)/((ssl-sprice)/Point);  }
   lot=NormalizeDouble(risk,2);
   if(lot<Minimum.Lot) lot=Minimum.Lot;
   if(Use.Money.Mgt==false)   {lot=Minimum.Lot;}
   return(lot);   }//end LotsOptimized

void comments()   {
   string day;
      if(DayOfWeek()==0) day="Sunday ";
      if(DayOfWeek()==1) day="Monday ";
      if(DayOfWeek()==2) day="Tuesday ";
      if(DayOfWeek()==3) day="Wednesday ";
      if(DayOfWeek()==4) day="Thursday ";
      if(DayOfWeek()==5) day="Friday ";

      comment=StringConcatenate("Last Tick: ",day,TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS));
      comment=comment+StringConcatenate("\nSwap Long ",MarketInfo(Symbol(),MODE_SWAPLONG));
      comment=comment+StringConcatenate("\nSwap Short ",MarketInfo(Symbol(),MODE_SWAPSHORT));
      comment=comment+StringConcatenate("\nAverage Longs:    ",bap," B.Lots: ",blots);
      comment=comment+StringConcatenate("\nAverage Shorts:   ",sap," S.Lots: ",slots);
      comment=comment+StringConcatenate("\nMargin*Risk:   ",-Margin*MaximumRisk);
      comment=comment+StringConcatenate("\nAccountProfit()   ",AccountProfit());
      comment=comment+StringConcatenate("\nMaxDrawDown       ",MaxDrawDown);
      comment=comment+StringConcatenate("\nAccountBalance()  ",AccountBalance());
      comment=comment+StringConcatenate("\nAccountEquity()   ",AccountEquity());
      comment=comment+StringConcatenate("\nAccountMargin()   ",AccountMargin());
      comment=comment+StringConcatenate("\nMaxMargin         ",MaxMargin);
      comment=comment+StringConcatenate("\nMax Adverse Excursion Longs: ",lmae," pips");
      comment=comment+StringConcatenate("\nMax Adverse Excursion Shorts: ",smae," pips");
      comment=comment+StringConcatenate("\nLProfit: $",LProfit," SProfit: $",SProfit);
      comment=comment+StringConcatenate("\nSwap Longs $",Lswap," Swap Shorts $",Sswap);
   Comment(comment);}//end comments()

void MAE()  {
//lmae=0; smae=0;
for(int i=0; i<OrdersHistoryTotal(); i++) {
   OrderSelect(i,SELECT_BY_POS,MODE_HISTORY);
   if(Symbol()==OrderSymbol() && (OrderType()==0) && OrderProfit()>0)  {
      ot=iBarShift(Symbol(),0,OrderOpenTime());
      ct=iBarShift(Symbol(),0,OrderCloseTime());
      if(ot!=ct && iLow(Symbol(),0,iLowest(Symbol(),0,1,ot-ct,ct))< OrderOpenPrice() && 
         (OrderOpenPrice()-iLow(OrderSymbol(),0,iLowest(Symbol(),0,1,ot-ct,ct))) / Point > lmae) {
         lmae=NormalizeDouble((OrderOpenPrice()-iLow(Symbol(),0,iLowest(Symbol(),0,1,ot-ct,ct)))/Point,0); }  }
   if(Symbol()==OrderSymbol() && (OrderType()==1) && OrderProfit()>0)  {
      ot=iBarShift(Symbol(),0,OrderOpenTime());
      ct=iBarShift(Symbol(),0,OrderCloseTime());
      if(ot!=ct && iHigh(Symbol(),0,iHighest(Symbol(),0,2,ot-ct,ct))> OrderOpenPrice() &&
         (iHigh(Symbol(),0,iHighest(Symbol(),0,2,ot-ct,ct))-OrderOpenPrice()) / Point > smae) {
         smae=NormalizeDouble((iHigh(Symbol(),0,iHighest(Symbol(),0,2,ot-ct,ct))-OrderOpenPrice())/Point,0); }  }   }  }